Add new skeleton ChangeLog file generator to contrib/
[gcc.git] / contrib / gcc_update
1 #! /bin/sh
2 #
3 # Update a local Subversion, Git or Mercurial tree from the GCC
4 # repository, with an emphasis on treating generated files correctly, so
5 # that autoconf, gperf et al are not required for the ``end'' user.
6 #
7 # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009, 2010,
8 # 2011 Free Software Foundation
9 # Originally by Gerald Pfeifer <pfeifer@dbai.tuwien.ac.at>, August 1998.
10 #
11 # This script is Free Software, and it can be copied, distributed and
12 # modified as defined in the GNU General Public License. A copy of
13 # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
14 #
15 #
16 # By default all command-line options are passed to `svn update` or `hg/git
17 # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18 # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
19 # are omitted.
20 #
21 # If the first parameter reads --patch, the second parameter is considered
22 # a patch file.
23 #
24 # If the first parameter is --touch, no svn operation will be performed,
25 # only generated files that appear to be out of date in the local tree
26 # will be touched.
27 #
28 # If the first parameter is --list, a list of the generated files and
29 # their dependencies will be printed; --help prints this message.
30 #
31 # If the first parameter is --silent, this script prints nothing other
32 # than error messages; the second parameter is then interpreted as above.
33 #
34 # Examples:
35 #
36 # contrib/gcc_update -r 8712
37 # contrib/gcc_update --patch some-patch
38 # contrib/gcc_update --touch
39 # contrib/gcc_update --list
40
41
42 # Default options used when updating (none).
43 UPDATE_OPTIONS=""
44
45 # Set the locale to C to make this script work for users with foreign
46 # locale like e.g. French UTF-8.
47 LANG=C
48 LC_ALL=C
49 export LANG LC_ALL
50
51 ######## Anything below shouldn't be changed by regular users.
52
53 # Arrange for the value of $0 to be available for functions
54 self=$0
55
56 # This function prints its arguments to standard output unless
57 # "silent" is set.
58 unset silent
59 chat () {
60 if [ -z "$silent" ]; then
61 echo "$@"
62 fi
63 }
64
65 # This function prints a list of all generated files, along with their
66 # dependencies. Note that only one target is supported per line: the
67 # colon is stripped from the output.
68 files_and_dependencies () {
69 sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
70 # fixincludes
71 fixincludes/configure: fixincludes/configure.ac fixincludes/aclocal.m4
72 fixincludes/config.h.in: fixincludes/configure.ac fixincludes/aclocal.m4
73 # intl library
74 intl/plural.c: intl/plural.y
75 intl/configure: intl/configure.ac intl/aclocal.m4
76 intl/config.h.in: intl/configure.ac intl/aclocal.m4
77 # Now, proceed to gcc automatically generated files
78 gcc/configure: gcc/configure.ac
79 gcc/cstamp-h.in: gcc/configure.ac
80 gcc/config.in: gcc/cstamp-h.in
81 gcc/fixinc/fixincl.x: gcc/fixinc/fixincl.tpl gcc/fixinc/inclhack.def
82 gcc/config/arm/arm-tune.md: gcc/config/arm/arm-cores.def gcc/config/arm/gentune.sh
83 gcc/config/arm/arm-tables.opt: gcc/config/arm/arm-arches.def gcc/config/arm/arm-cores.def gcc/config/arm/arm-fpus.def gcc/config/arm/genopt.sh
84 gcc/config/avr/avr-tables.opt: gcc/config/avr/avr-mcus.def gcc/config/avr/genopt.sh
85 gcc/config/avr/t-multilib: gcc/config/avr/avr-mcus.def gcc/config/avr/genmultilib.awk
86 gcc/config/c6x/c6x-tables.opt: gcc/config/c6x/c6x-isas.def gcc/config/c6x/genopt.sh
87 gcc/config/c6x/c6x-sched.md: gcc/config/c6x/c6x-sched.md.in gcc/config/c6x/gensched.sh
88 gcc/config/c6x/c6x-mult.md: gcc/config/c6x/c6x-mult.md.in gcc/config/c6x/genmult.sh
89 gcc/config/m68k/m68k-tables.opt: gcc/config/m68k/m68k-devices.def gcc/config/m68k/m68k-isas.def gcc/config/m68k/m68k-microarchs.def gcc/config/m68k/genopt.sh
90 gcc/config/mips/mips-tables.opt: gcc/config/mips/mips-cpus.def gcc/config/mips/genopt.sh
91 gcc/config/rs6000/rs6000-tables.opt: gcc/config/rs6000/rs6000-cpus.def gcc/config/rs6000/genopt.sh
92 gcc/config/tilegx/mul-tables.c: gcc/config/tilepro/gen-mul-tables.cc
93 gcc/config/tilepro/mul-tables.c: gcc/config/tilepro/gen-mul-tables.cc
94 # And then, language-specific files
95 gcc/cp/cfns.h: gcc/cp/cfns.gperf
96 gcc/java/keyword.h: gcc/java/keyword.gperf
97 # testsuite
98 # Without this, _Pragma3.c can have a false negative.
99 gcc/testsuite/gcc.dg/cpp/_Pragma3.c: gcc/testsuite/gcc.dg/cpp/mi1c.h
100 # Similarly, without this, you will see:
101 # direct2s.c:35: warning: current file is older than direct2.c
102 gcc/testsuite/gcc.dg/cpp/direct2s.c: gcc/testsuite/gcc.dg/cpp/direct2.c
103 # lto-plugin
104 lto-plugin/configure: lto-plugin/configure.ac lto-plugin/aclocal.m4
105 lto-plugin/Makefile.in: lto-plugin/Makefile.am lto-plugin/aclocal.m4
106 # And libraries, at last
107 libbanshee/configure: libbanshee/configure.ac
108 libmudflap/configure: libmudflap/configure.ac
109 libobjc/configure: libobjc/configure.ac
110 zlib/aclocal.m4: zlib/configure.ac zlib/acinclude.m4
111 zlib/Makefile.in: zlib/Makefile.am zlib/configure.ac zlib/aclocal.m4
112 zlib/configure: zlib/configure.ac zlib/aclocal.m4
113 fastjar/aclocal.m4: fastjar/configure.ac
114 fastjar/Makefile.in: fastjar/Makefile.am fastjar/configure.ac fastjar/aclocal.m4
115 fastjar/configure: fastjar/configure.ac fastjar/aclocal.m4
116 boehm-gc/aclocal.m4: boehm-gc/configure.ac
117 boehm-gc/Makefile.in: boehm-gc/Makefile.am boehm-gc/configure.ac boehm-gc/aclocal.m4
118 boehm-gc/configure: boehm-gc/configure.ac boehm-gc/aclocal.m4
119 libada/configure: libada/configure.ac
120 libffi/aclocal.m4: libffi/configure.ac libffi/acinclude.m4
121 libffi/Makefile.in: libffi/Makefile.am libffi/configure.ac libffi/aclocal.m4
122 libffi/configure: libffi/configure.ac libffi/aclocal.m4
123 libffi/fficonfig.h.in: libffi/configure.ac libffi/aclocal.m4
124 libgfortran/aclocal.m4: libgfortran/configure.ac libgfortran/acinclude.m4
125 libgfortran/Makefile.in: libgfortran/Makefile.am libgfortran/configure.ac libgfortran/aclocal.m4
126 libgfortran/configure: libgfortran/configure.ac libgfortran/aclocal.m4
127 libjava/aclocal.m4: libjava/configure.ac
128 libjava/Makefile.in: libjava/Makefile.am libjava/configure.ac libjava/aclocal.m4
129 libjava/configure: libjava/configure.ac libjava/aclocal.m4
130 libjava/libltdl/aclocal.m4: libjava/libltdl/configure.ac libjava/libltdl/acinclude.m4
131 libjava/libltdl/Makefile.in: libjava/libltdl/Makefile.am libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
132 libjava/libltdl/configure: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
133 libjava/libltdl/config-h.in: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
134 libcpp/aclocal.m4: libcpp/configure.ac
135 libcpp/Makefile.in: libcpp/configure.ac libcpp/aclocal.m4
136 libcpp/configure: libcpp/configure.ac libcpp/aclocal.m4
137 libgomp/aclocal.m4: libgomp/configure.ac libgomp/acinclude.m4
138 libgomp/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
139 libgomp/testsuite/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
140 libgomp/configure: libgomp/configure.ac libgomp/aclocal.m4
141 libgomp/config.h.in: libgomp/configure.ac libgomp/aclocal.m4
142 libitm/aclocal.m4: libitm/configure.ac libitm/acinclude.m4
143 libitm/Makefile.in: libitm/Makefile.am libitm/aclocal.m4
144 libitm/testsuite/Makefile.in: libitm/testsuite/Makefile.am libitm/aclocal.m4
145 libitm/configure: libitm/configure.ac libitm/aclocal.m4
146 libitm/config.h.in: libitm/configure.ac libitm/aclocal.m4
147 libatomic/aclocal.m4: libatomic/configure.ac libatomic/acinclude.m4
148 libatomic/Makefile.in: libatomic/Makefile.am libatomic/aclocal.m4
149 libatomic/testsuite/Makefile.in: libatomic/testsuite/Makefile.am libatomic/aclocal.m4
150 libatomic/configure: libatomic/configure.ac libatomic/aclocal.m4
151 libatomic/auto-config.h.in: libatomic/configure.ac libatomic/aclocal.m4
152 # Top level
153 Makefile.in: Makefile.tpl Makefile.def
154 configure: configure.ac config/acx.m4
155 EOF
156 }
157
158
159 # This function touches generated files such that the ``end'' user does
160 # not have to rebuild them.
161 touch_files () {
162 rm -f Makefile.$$
163 echo 'all: \' > Makefile.$$
164 files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
165 echo '; @true' >> Makefile.$$
166 files_and_dependencies | sed 's, ,: ,' >> Makefile.$$
167 files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
168 echo ':' >> Makefile.$$
169 echo ' @for f in $? $@; do test -f $$f || exit 0; done; \' >> Makefile.$$
170 echo ' echo Touching $@...; \' >> Makefile.$$
171 chat ' echo Touching $@... 1>&2; \' >> Makefile.$$
172 echo ' touch $@' >> Makefile.$$
173 files_and_dependencies | sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
174
175 # We would have to explicitly shut off the "Entering... Leaving..."
176 # messages through "--no-print-directory" to handle the case when
177 # we were called from a recursive invocation (i.e. "$(MAKE)" in a
178 # Makefile, not just make). Passing only "-s" doesn't help then,
179 # because make has helpfully added "-w" to MAKEFLAGS automatically.
180 # Unfortunately we do not require GNU make other than for building
181 # and testing, so let's just grep known text explicitly echoed by
182 # the rule.
183 while ${MAKE-make} -s -f Makefile.$$ all | grep Touching > /dev/null; do
184 sleep 1
185 done 2>&1
186 rm -f Makefile.$$
187 }
188
189
190 # Whenever we update the tree or install a patch, we may be modifying
191 # this script. By re-execing it, we ensure that the appropriate
192 # dependencies and rules will be used.
193 touch_files_reexec () {
194 chat "Adjusting file timestamps"
195 exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
196 }
197
198 # This functions applies a patch to an existing tree.
199 apply_patch () {
200 if [ -f "$1" ]; then
201 echo "Applying patch file $1"
202 case $1 in
203 *gz)
204 gzip -d -c "$1" | patch -p1 ;;
205 *bz2)
206 bzip2 -d -c "$1" | patch -p1 ;;
207 *)
208 patch -p1 < "$1";;
209 esac
210 fi
211 touch_files_reexec
212 }
213
214 # Check whether this indeed looks like a local tree.
215 if [ ! -f gcc/version.c ]; then
216 echo "This does not seem to be a GCC tree!"
217 exit
218 fi
219
220 case "$1" in
221 --silent)
222 silent=t
223 shift
224 ;;
225 esac
226
227 case "$1" in
228 # First of all, check whether we are going to process a patch.
229 --patch)
230 if test "$#" != 2; then
231 echo "$1" expects only one argument >&2
232 exit 1
233 fi
234 apply_patch "${2}"
235 exit $?
236 ;;
237
238 --touch)
239 if test "$#" != 1; then
240 echo "$1" does not expect any argument >&2
241 exit 1
242 fi
243 touch_files
244 exit $?
245 ;;
246
247 --list)
248 if test "$#" != 1; then
249 echo "$1" does not expect any argument >&2
250 exit 1
251 fi
252 files_and_dependencies | sed 's/ /: /'
253 exit $?
254 ;;
255
256 --help)
257 sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
258 \
259
260 p
261 }' \
262 -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
263 exit $?
264 ;;
265
266 esac
267
268 # Check for known version control systems.
269 if [ -d .git ]; then
270 GCC_GIT=${GCC_GIT-${GIT-git}}
271 vcs_type="git"
272 elif [ -d .hg ]; then
273 GCC_HG=${GCC_HG-${HG-hg}}
274 vcs_type="hg"
275 elif [ -d .svn ]; then
276 GCC_SVN=${GCC_SVN-${SVN-svn}}
277 vcs_type="svn"
278 else
279 echo "This does not seem to be a GCC GIT/HG/SVN tree!"
280 exit
281 fi
282
283 # Check command-line options
284 if [ x"${1}"x = x"--nostdflags"x ]; then
285 shift
286 else
287 set -- $UPDATE_OPTIONS ${1+"$@"}
288 fi
289
290 case $vcs_type in
291 git)
292 chat "Updating GIT tree"
293
294 $GCC_GIT diff --quiet --exit-code HEAD
295 if [ $? -ne 0 ]; then
296 echo "Attempting to update a dirty git tree!" >&2
297 echo "Commit or stash your changes first and retry." >&2
298 exit 1
299 fi
300
301 $GCC_GIT pull ${silent+-q} --rebase ${1+"$@"}
302 if [ $? -ne 0 ]; then
303 (touch_files_reexec)
304 echo "git pull of full tree failed." >&2
305 exit 1
306 fi
307
308 revision=`$GCC_GIT log -n1 --pretty=%p:%t:%H`
309 branch=`$GCC_GIT name-rev --name-only HEAD || :`
310 ;;
311
312 hg)
313 chat "Updating HG tree"
314
315 # Add -q so untracked files aren't listed.
316 if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
317 echo "Attempting to update a dirty hg tree!" >&2
318 echo "Commit or revert your changes first and retry." >&2
319 exit 1
320 fi
321
322 # Check for mq extension. mq patches must be popped so tip has
323 # been converted from the SVN tree.
324 if [ -d .hg/patches ] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
325 # FIXME: Perhaps pop queue instead? We could do that since we
326 # know the tree is clean.
327 echo "Attempting to update hg tree with mq patches applied!" >&2
328 echo "Pop your patches first and retry." >&2
329 exit 1
330 fi
331
332 # Update tree, but make sure to only pull the default branch.
333 # Otherwise all branches in the upstream repo are added, even if
334 # only a single one has been cloned.
335 $GCC_HG pull ${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
336 if [ $? -ne 0 ]; then
337 (touch_files_reexec)
338 echo "hg pull of full tree failed." >&2
339 exit 1
340 fi
341
342 # Update tree. Needs to be done separately from pull so
343 # gcc_update -rREV works.
344 $GCC_HG update ${silent+-q} ${1+"$@"}
345 if [ $? -ne 0 ]; then
346 (touch_files_reexec)
347 echo "hg update of full tree failed." >&2
348 exit 1
349 fi
350
351 # Extract SVN revision corresponding to parents, as stored by
352 # hg convert. Before hg 1.4.3, there's no template keyword
353 # corresponding to the extra: tag, so need to use hg log --debug
354 # to extract the info.
355 parents=`$GCC_HG parents --template '{rev}'`
356 convert_revision=`$GCC_HG log --debug -r$parents | \
357 sed -ne "/^extra:.*convert_revision=svn:/ {
358 s%^[^/]*/%%
359 p
360 }"`
361 revision=`echo $convert_revision | sed -e 's/.*@//'`
362 branch=`echo $convert_revision | sed -e 's%branches/%%' -e 's/@.*//'`
363 ;;
364
365 svn)
366 chat "Updating SVN tree"
367
368 $GCC_SVN ${silent+-q} --non-interactive update ${1+"$@"}
369 if [ $? -ne 0 ]; then
370 (touch_files_reexec)
371 echo "SVN update of full tree failed." >&2
372 exit 1
373 fi
374
375 revision=`$GCC_SVN info | awk '/Revision:/ { print $2 }'`
376 branch=`$GCC_SVN info | sed -ne "/URL:/ {
377 s,.*/trunk,trunk,
378 s,.*/branches/,,
379 s,.*/tags/,,
380 p
381 }"`
382 ;;
383 esac
384
385 rm -f LAST_UPDATED gcc/REVISION
386 {
387 date
388 echo "`TZ=UTC date` (revision $revision)"
389 } > LAST_UPDATED
390 echo "[$branch revision $revision]" > gcc/REVISION
391
392 touch_files_reexec